//
//  ViewController.swift
//  iOSHypeCalls
//
//  Created by Mark Hunte on 18/09/2016.
//  Copyright © 2016 Mark Hunte. All rights reserved.
//

import UIKit
import WebKit
class ViewController: UIViewController ,WKScriptMessageHandler{
    
    @IBOutlet var containerView : UIView! = nil
    
    var webView: WKWebView?
    var   thisUrl = ""
    
    override func loadView() {
        super.loadView()
        
    

       let userController = WKUserContentController.init();
      
       userController.add(
            self,
            name: "callbackHandler"
        )
        
     let viewConfig = WKWebViewConfiguration.init()
        viewConfig.userContentController = userController
        
        self.webView = WKWebView(frame: self.view.frame, configuration: viewConfig)
        
       
        self.view = self.webView!
        
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        let theUrl = Bundle.main.url(forResource: "hypeXCodeCall", withExtension:"html")
        let req = NSURLRequest(url: theUrl!)
        self.webView!.load(req as URLRequest)
    }

    
    func userContentController(_ userContentController: WKUserContentController, didReceive message: WKScriptMessage) {
        
        thisUrl = message.body as! String
        guard let theUrl = URL(string: "\(message.body)") else {
           print("JavaScript is sending bad URL \"\(thisUrl)\"")
          
            urlError()
            return
        }
        
       
        
            if(message.name == "callbackHandler") {
                    print("JavaScript is sending a message \"\(theUrl)\"")
                 UIApplication.shared.open(theUrl)
                
              
                 }
    }
   
    
   
    func urlError()  {
        
        
        self.webView!.evaluateJavaScript("window.badURL=\'\"\(thisUrl)\"\';HYPE.documents['hypeXCodeCall'].showSceneNamed('badURL', HYPE.documents['hypeXCodeCall'].kSceneTransitionCrossfade, 0.2);", completionHandler:nil )
        
    }
    
    
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
        
        
        
    }
    
    
}

